"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ReportEvent(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "eventJustification",
        "genomicFeature",
        "modeOfInheritance",
        "penetrance",
        "phenotype",
        "reportEventId",
        "score",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "genomicFeature": reports_2_1_0.GenomicFeature,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "modeOfInheritance": reports_2_1_0.ReportedModeOfInheritance,
            "penetrance": reports_2_1_0.Penetrance,
            "tier": reports_2_1_0.Tier,
            "variantClassification": reports_2_1_0.VariantClassification,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_2_1_0 import reports as reports_2_1_0

        return {
            "Gel_BioInf_Models.GenomicFeature": reports_2_1_0.GenomicFeature,
            "Gel_BioInf_Models.ReportedModeOfInheritance": reports_2_1_0.ReportedModeOfInheritance,
            "Gel_BioInf_Models.Penetrance": reports_2_1_0.Penetrance,
            "Gel_BioInf_Models.Tier": reports_2_1_0.Tier,
            "Gel_BioInf_Models.VariantClassification": reports_2_1_0.VariantClassification,
            "Gel_BioInf_Models.ReportEvent": reports_2_1_0.ReportEvent,
        }

    __slots__ = [
        "eventJustification",
        "genomicFeature",
        "modeOfInheritance",
        "penetrance",
        "phenotype",
        "reportEventId",
        "score",
        "fullyExplainsPhenotype",
        "groupOfVariants",
        "panelName",
        "panelVersion",
        "tier",
        "variantClassification",
        "vendorSpecificScores",
    ]

    def __init__(
        self,
        eventJustification,
        genomicFeature,
        modeOfInheritance,
        penetrance,
        phenotype,
        reportEventId,
        score,
        fullyExplainsPhenotype=None,
        groupOfVariants=None,
        panelName=None,
        panelVersion=None,
        tier=None,
        variantClassification=None,
        vendorSpecificScores=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_2_1_0.ReportEvent model.

        :param eventJustification:
            This is the description of why this variant would be reported, for
            example that it affects the protein in this way     and
            that this gene has been implicated in this disorder in
            these publications. Publications should be provided as
            PMIDs     using the format [PMID:8075643]. Other sources
            can be used in the same manner, e.g. [OMIM:163500].
            Brackets need to be included.
        :type eventJustification: str
        :param genomicFeature:
            This is the genomicsFeature of interest for this reported variant,
            please note that one variant can overlap more that one
            gene/transcript     If more than one gene/transcript is
            considered interesting for this particular variant, should
            be reported in two different ReportEvents
        :type genomicFeature: GenomicFeature
        :param modeOfInheritance:
            Mode of inheritance used to analyze the family
        :type modeOfInheritance: ReportedModeOfInheritance
        :param penetrance:
            This is the penetrance assumed for scoring or classifying this variant
        :type penetrance: Penetrance
        :param phenotype:
            This is the phenotype (usually the HPO term or the disorder name)
            considered to report this variant
        :type phenotype: str
        :param reportEventId:
            Unique identifier for each report event, this has to be unique across
            the whole report, and it will be used by GEL     to
            validate the report
        :type reportEventId: str
        :param score:
            This is the score provided by the company to reflect a variant's
            likelihood of explaining the phenotype using     a
            specific mode of Inheritance
        :type score: float
        :param fullyExplainsPhenotype:
            This variant using this mode of inheritance can fully explain the
            phenotype? true or false
        :type fullyExplainsPhenotype: None | boolean
        :param groupOfVariants:
            This value groups variants that together could explain the phenotype
            according to the     mode of inheritance used. All the
            variants sharing the same value will be considered in the
            same group.     This value is an integer unique in the
            whole analysis.
        :type groupOfVariants: None | int
        :param panelName:
            Gene Panel used from panelApp
        :type panelName: None | str
        :param panelVersion:
            Gene Panel Version
        :type panelVersion: None | str
        :param tier:
            Tier is a property of the model of inheritance and therefore is
            subject to change depending on the inheritance assumptions
            This should be filled with the information provided by GEL
        :type tier: None | Tier
        :param variantClassification:
            Classification of the pathogenicity of this variant with respect to
            the phenotype
        :type variantClassification: None | VariantClassification
        :param vendorSpecificScores:
            Other scores that the interpretation provider may add (for example
            phenotypically informed or family informed scores)
        :type vendorSpecificScores: None | dict[str, float]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.1.0"
